ServiceScope
Date: 2016-06-25

org.osgi.service.component.annotations

## Enum ServiceScope

- java.lang.Object
- - java.lang.Enum<ServiceScope>
  - - org.osgi.service.component.annotations.ServiceScope

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<ServiceScope>

      public enum ServiceScope
      extends java.lang.Enum<ServiceScope>

  Service scope for the `Component` annotation.
  Since:
    1.3

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BUNDLE` When the component is registered as a service, it must be registered as a bundle scope service and an instance of the component must be created for each bundle using the service.
    `DEFAULT` Default element value for annotation.
    `PROTOTYPE` When the component is registered as a service, it must be registered as a prototype scope service and an instance of the component must be created for each distinct request for the service.
    `SINGLETON` When the component is registered as a service, it must be registered as a bundle scope service but only a single instance of the component must be used for all bundles using the service.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `toString()`
    `static ServiceScope` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static ServiceScope[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### SINGLETON

          public static final ServiceScope SINGLETON

      When the component is registered as a service, it must be registered as a bundle scope service but only a single instance of the component must be used for all bundles using the service.

    - #### BUNDLE

          public static final ServiceScope BUNDLE

      When the component is registered as a service, it must be registered as a bundle scope service and an instance of the component must be created for each bundle using the service.

    - #### PROTOTYPE

          public static final ServiceScope PROTOTYPE

      When the component is registered as a service, it must be registered as a prototype scope service and an instance of the component must be created for each distinct request for the service.

    - #### DEFAULT

          public static final ServiceScope DEFAULT

      Default element value for annotation. This is used to distinguish the default value for an element and should not otherwise be used.

  - ### Method Detail

    - #### values

          public static ServiceScope[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ServiceScope c : ServiceScope.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ServiceScope valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Enum<ServiceScope>`